/*
   Class Name:

      CCamera.

   Created by:

      Allen Sherrod (Programming Ace of www.UltimateGameProgramming.com).

   Description:

      This class represents a camera in a 3D scene.
*/


#include<math.h>
#include"CCamera.h"


CCamera::CCamera()
{
   // Initialize variables...
   xPos, yPos, zPos = 0;
   xView, yView, zView = 0;
   xUp, yUp, zUp = 0;
}


void CCamera::SetCamera(float x, float y, float z,
                        float xv, float yv, float zv,
                        float xu, float yu, float zu)
{
   // Here we set the camera to the values sent in to us.  This is mostly used to set up a
   // default position.
   xPos = x;   yPos = y;   zPos = z;
   xView = xv; yView = yv; zView = zv;
   xUp = xu;   yUp = yu;   zUp = zu;
}


void CCamera::MoveCamera(float directionSpeed)
{
   // Moving the camera requires a little more then adding 1 to the z or subracting 1.
   // First we need to get the direction at which we are looking.
   float xLookDirection, yLookDirection, zLookDirection = 0;

   // The look direction is the view (where we are looking) minus the position (where we are).
   xLookDirection = xView - xPos;
	yLookDirection = yView - yPos;
	zLookDirection = zView - zPos;

   // To correctly move the camera foward and backwards we simply add the result of the
   // look direction * the speed of our camera to get the new positions.  This will move the
   // camera but what about the view?  If the view was set to look at the point (0, 0, 0)
   // then when we move the camera forwards or backwards the camera's view will stay
   // focused on that one point.  Image walking down the street and you see a pretty girl.
   // Your view will be locked on to the girl but your position is still moving forward
   // because your still walking.  Makes sense.  So with our camera think of the point (0, 0, 0)
   // or what ever point it is looking at as that pretty girl.  To correct this so we are always
   // looking foward we do the same to the view as we do the position.

   // Move the camera on the X and Z axis.
	xPos += xLookDirection * directionSpeed;
	zPos += zLookDirection * directionSpeed;

   // Move the view along with the position
	xView += xLookDirection * directionSpeed;
	zView += zLookDirection * directionSpeed;

   // NOTE if the camera moves too slow try increasing the UP and DOWN values in the header.
   // The camera is frame based so it will move differently for you (unless you have the same
   // PC specs as me).
}


// Copyright September 2004
// All Rights Reserved!
// Allen Sherrod
// ProgrammingAce@UltimateGameProgramming.com
// www.UltimateGameProgramming.com