/*
   Class Name:

      CCamera.

   Created by:

      Allen Sherrod (Programming Ace of www.UltimateGameProgramming.com).

   Description:

      This class represents a camera in a 3D scene.
*/


#ifndef CCAMERA_H
#define CCAMERA_H

#define UP     0.03f    // Forward speed.
#define DOWN   -0.03f   // Backward speed.


class CCamera
{
   public:
      CCamera();                                      // Constructor.

      void SetCamera(float x, float y, float z,       // Set the camera's position.
                     float xv, float yv, float zv,
                     float xu, float yu, float zu);

      void MoveCamera(float directionSpeed);          // Move the camera forwards and backwards.

      float xPos, yPos, zPos;                         // Camera position.
      float xView, yView, zView;                      // Look at position.
      float xUp, yUp, zUp;                            // Up direction.
};

#endif


// Copyright September 2004
// All Rights Reserved!
// Allen Sherrod
// ProgrammingAce@UltimateGameProgramming.com
// www.UltimateGameProgramming.com